
import re

from mandaye.response import serve_template

def biblio_html_login_page(env, values, request, response):
    """ msg: response message body
    env: Mandaye environment
    """
    response.msg = re.sub("</center></div>",
            "<a href=\"/mandaye/connection\">Connection via mon compte citoyen</center></div>",
            response.msg)
    return response

def biblio_html(env, values, request, response):
    """ Global html filter the Vincenne library
    This fix the fucking absolute url of the biblio site
    """
    response.msg = response.msg.replace(env["target"].hostname, env["HTTP_HOST"])
    return response

def biblio_associate_req(env, values, request):
    """ Modify the association request
    """
    request.req_method = 'GET'
    if request.headers.has_key('Content-Type'):
        del request.headers['Content-Type']
    return request

def biblio_associate_login(env, values, request, response):
    """ Use default login page to associate an account on the SSO
    """
    pattern = re.compile('<div class="inner">.*</center></div>\s+</div></div>',
            re.MULTILINE | re.DOTALL)
    form = serve_template(values.get('template'), **values)
    form = form.encode('utf-8')
    response.msg = re.sub(pattern, form, response.msg)
    return response

